osgUtil::SceneView Class Reference

`#include <SceneView>`

Inheritance diagram for osgUtil::SceneView:

## Classes

struct | ComputeStereoMatricesCallback

## Public Types

enum | Options { NO_SCENEVIEW_LIGHT = 0x0 , HEADLIGHT = 0x1 , SKY_LIGHT = 0x2 , COMPILE_GLOBJECTS_AT_INIT = 0x4 , APPLY_GLOBAL_DEFAULTS = 0x8 , CLEAR_GLOBAL_STATESET = 0x10 , STANDARD_SETTINGS }
enum | ActiveUniforms { FRAME_NUMBER_UNIFORM = 1 , FRAME_TIME_UNIFORM = 2 , DELTA_FRAME_TIME_UNIFORM = 4 , SIMULATION_TIME_UNIFORM = 8 , DELTA_SIMULATION_TIME_UNIFORM = 16 , VIEW_MATRIX_UNIFORM = 32 , VIEW_MATRIX_INVERSE_UNIFORM = 64 , DEFAULT_UNIFORMS , ALL_UNIFORMS = 0x7FFFFFFF }
enum | FusionDistanceMode { USE_FUSION_DISTANCE_VALUE , PROPORTIONAL_TO_SCREEN_DISTANCE }
typedef Options | LightingMode
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Public Types inherited from osg::CullSettings

enum

VariablesMask {
COMPUTE_NEAR_FAR_MODE = (0x1 << 0) , CULLING_MODE = (0x1 << 1) , LOD_SCALE = (0x1 << 2) , SMALL_FEATURE_CULLING_PIXEL_SIZE = (0x1 << 3) ,
CLAMP_PROJECTION_MATRIX_CALLBACK = (0x1 << 4) , NEAR_FAR_RATIO = (0x1 << 5) , IMPOSTOR_ACTIVE = (0x1 << 6) , DEPTH_SORT_IMPOSTOR_SPRITES = (0x1 << 7) ,
IMPOSTOR_PIXEL_ERROR_THRESHOLD = (0x1 << 8) , NUM_FRAMES_TO_KEEP_IMPOSTORS_SPRITES = (0x1 << 9) , CULL_MASK = (0x1 << 10) , CULL_MASK_LEFT = (0x1 << 11) ,
CULL_MASK_RIGHT = (0x1 << 12) , CLEAR_COLOR = (0x1 << 13) , CLEAR_MASK = (0x1 << 14) , LIGHTING_MODE = (0x1 << 15) ,
LIGHT = (0x1 << 16) , DRAW_BUFFER = (0x1 << 17) , READ_BUFFER = (0x1 << 18) , NO_VARIABLES = 0x00000000 ,
ALL_VARIABLES = 0x7FFFFFFF
}

enum | InheritanceMaskActionOnAttributeSetting { DISABLE_ASSOCIATED_INHERITANCE_MASK_BIT , DO_NOT_MODIFY_INHERITANCE_MASK }
enum | ComputeNearFarMode { DO_NOT_COMPUTE_NEAR_FAR = 0 , COMPUTE_NEAR_FAR_USING_BOUNDING_VOLUMES , COMPUTE_NEAR_FAR_USING_PRIMITIVES , COMPUTE_NEAR_USING_PRIMITIVES }
enum | CullingModeValues { NO_CULLING = 0x0 , VIEW_FRUSTUM_SIDES_CULLING = 0x1 , NEAR_PLANE_CULLING = 0x2 , FAR_PLANE_CULLING = 0x4 , VIEW_FRUSTUM_CULLING , SMALL_FEATURE_CULLING = 0x8 , SHADOW_OCCLUSION_CULLING = 0x10 , CLUSTER_CULLING = 0x20 , DEFAULT_CULLING , ENABLE_ALL_CULLING }
typedef int | InheritanceMask
typedef int | CullingMode

## Public Member Functions

| SceneView (osg::DisplaySettings *ds=NULL)
| SceneView (const SceneView &sceneview, const osg::CopyOp &copyop=osg::CopyOp())
| META_Object (osgUtil, SceneView)
virtual void | setDefaults ()
virtual void | setDefaults (unsigned int options)
void | setCamera (osg::Camera *camera, bool assumeOwnershipOfCamera=true)
osg::Camera * | getCamera ()
const osg::Camera * | getCamera () const
void | setSceneData (osg::Node *node)
osg::Node * | getSceneData (unsigned int childNo=0)
const osg::Node * | getSceneData (unsigned int childNo=0) const
unsigned int | getNumSceneData () const
void | setViewport (osg::Viewport *viewport)
void | setViewport (int x, int y, int width, int height)
osg::Viewport * | getViewport ()
const osg::Viewport * | getViewport () const
void | setDisplaySettings (osg::DisplaySettings *vs)
const osg::DisplaySettings * | getDisplaySettings () const
osg::DisplaySettings * | getDisplaySettings ()
void | setClearColor (const osg::Vec4 &color)
const osg::Vec4 & | getClearColor () const
void | setRedrawInterlacedStereoStencilMask (bool flag)
bool | getRedrawInterlacedStereoStencilMask () const
void | setGlobalStateSet (osg::StateSet *state)
osg::StateSet * | getGlobalStateSet ()
const osg::StateSet * | getGlobalStateSet () const
void | setSecondaryStateSet (osg::StateSet *state)
osg::StateSet * | getSecondaryStateSet ()
const osg::StateSet * | getSecondaryStateSet () const
void | setLocalStateSet (osg::StateSet *state)
osg::StateSet * | getLocalStateSet ()
const osg::StateSet * | getLocalStateSet () const
void | setActiveUniforms (int activeUniforms)
int | getActiveUniforms () const
void | updateUniforms ()
void | setLightingMode (LightingMode mode)
LightingMode | getLightingMode () const
void | setLight (osg::Light *light)
osg::Light * | getLight ()
const osg::Light * | getLight () const
void | setState (osg::State *state)
osg::State * | getState ()
const osg::State * | getState () const
void | setView (osg::View *view)
osg::View * | getView ()
const osg::View * | getView () const
void | setRenderInfo (osg::RenderInfo &renderInfo)
osg::RenderInfo & | getRenderInfo ()
const osg::RenderInfo & | getRenderInfo () const
void | setProjectionMatrix (const osg::Matrixf &matrix)
void | setProjectionMatrix (const osg::Matrixd &matrix)
void | setProjectionMatrixAsOrtho (double left, double right, double bottom, double top, double zNear, double zFar)
void | setProjectionMatrixAsOrtho2D (double left, double right, double bottom, double top)
void | setProjectionMatrixAsFrustum (double left, double right, double bottom, double top, double zNear, double zFar)
void | setProjectionMatrixAsPerspective (double fovy, double aspectRatio, double zNear, double zFar)
osg::Matrixd & | getProjectionMatrix ()
const osg::Matrixd & | getProjectionMatrix () const
bool | getProjectionMatrixAsOrtho (double &left, double &right, double &bottom, double &top, double &zNear, double &zFar) const
bool | getProjectionMatrixAsFrustum (double &left, double &right, double &bottom, double &top, double &zNear, double &zFar) const
bool | getProjectionMatrixAsPerspective (double &fovy, double &aspectRatio, double &zNear, double &zFar) const
void | setViewMatrix (const osg::Matrixf &matrix)
void | setViewMatrix (const osg::Matrixd &matrix)
void | setViewMatrixAsLookAt (const osg::Vec3 &eye, const osg::Vec3 &center, const osg::Vec3 &up)
osg::Matrixd & | getViewMatrix ()
const osg::Matrixd & | getViewMatrix () const
void | getViewMatrixAsLookAt (osg::Vec3 &eye, osg::Vec3 &center, osg::Vec3 &up, float lookDistance=1.0f) const
void | setInitVisitor (osg::NodeVisitor *av)
osg::NodeVisitor * | getInitVisitor ()
const osg::NodeVisitor * | getInitVisitor () const
void | setUpdateVisitor (osg::NodeVisitor *av)
osg::NodeVisitor * | getUpdateVisitor ()
const osg::NodeVisitor * | getUpdateVisitor () const
void | setCullVisitor (osgUtil::CullVisitor *cv)
osgUtil::CullVisitor * | getCullVisitor ()
const osgUtil::CullVisitor * | getCullVisitor () const
void | setCullVisitorLeft (osgUtil::CullVisitor *cv)
osgUtil::CullVisitor * | getCullVisitorLeft ()
const osgUtil::CullVisitor * | getCullVisitorLeft () const
void | setCullVisitorRight (osgUtil::CullVisitor *cv)
osgUtil::CullVisitor * | getCullVisitorRight ()
const osgUtil::CullVisitor * | getCullVisitorRight () const
void | setCollectOccludersVisitor (osg::CollectOccludersVisitor *cov)
osg::CollectOccludersVisitor * | getCollectOccludersVisitor ()
const osg::CollectOccludersVisitor * | getCollectOccludersVisitor () const
void | setStateGraph (osgUtil::StateGraph *rg)
osgUtil::StateGraph * | getStateGraph ()
const osgUtil::StateGraph * | getStateGraph () const
void | setStateGraphLeft (osgUtil::StateGraph *rg)
osgUtil::StateGraph * | getStateGraphLeft ()
const osgUtil::StateGraph * | getStateGraphLeft () const
void | setStateGraphRight (osgUtil::StateGraph *rg)
osgUtil::StateGraph * | getStateGraphRight ()
const osgUtil::StateGraph * | getStateGraphRight () const
void | setRenderStage (osgUtil::RenderStage *rs)
osgUtil::RenderStage * | getRenderStage ()
const osgUtil::RenderStage * | getRenderStage () const
void | setRenderStageLeft (osgUtil::RenderStage *rs)
osgUtil::RenderStage * | getRenderStageLeft ()
const osgUtil::RenderStage * | getRenderStageLeft () const
void | setRenderStageRight (osgUtil::RenderStage *rs)
osgUtil::RenderStage * | getRenderStageRight ()
const osgUtil::RenderStage * | getRenderStageRight () const
void | collateReferencesToDependentCameras ()
void | clearReferencesToDependentCameras ()
void | setDrawBufferValue (GLenum drawBufferValue)
GLenum | getDrawBufferValue () const
void | setFusionDistance (FusionDistanceMode mode, float value=1.0f)
FusionDistanceMode | getFusionDistanceMode () const
float | getFusionDistanceValue () const
void | setPrioritizeTextures (bool pt)
bool | getPrioritizeTextures () const
void | setComputeStereoMatricesCallback (ComputeStereoMatricesCallback *callback)
ComputeStereoMatricesCallback * | getComputeStereoMatricesCallback ()
const ComputeStereoMatricesCallback * | getComputeStereoMatricesCallback () const
bool | projectWindowIntoObject (const osg::Vec3 &window, osg::Vec3 &object) const
bool | projectWindowXYIntoObject (int x, int y, osg::Vec3 &near_point, osg::Vec3 &far_point) const
bool | projectObjectIntoWindow (const osg::Vec3 &object, osg::Vec3 &window) const
void | setFrameStamp (osg::FrameStamp *fs)
osg::FrameStamp * | getFrameStamp ()
const osg::FrameStamp * | getFrameStamp () const
osg::Matrixd | computeLeftEyeProjection (const osg::Matrixd &projection) const
osg::Matrixd | computeLeftEyeView (const osg::Matrixd &view) const
osg::Matrixd | computeRightEyeProjection (const osg::Matrixd &projection) const
osg::Matrixd | computeRightEyeView (const osg::Matrixd &view) const
virtual osg::Matrixd | computeLeftEyeProjectionImplementation (const osg::Matrixd &projection) const
virtual osg::Matrixd | computeLeftEyeViewImplementation (const osg::Matrixd &view) const
virtual osg::Matrixd | computeRightEyeProjectionImplementation (const osg::Matrixd &projection) const
virtual osg::Matrixd | computeRightEyeViewImplementation (const osg::Matrixd &view) const
virtual void | inheritCullSettings (const osg::CullSettings &settings)
virtual void | inheritCullSettings (const osg::CullSettings &settings, unsigned int inheritanceMask)
virtual void | init ()
virtual void | update ()
virtual void | cull ()
virtual void | draw ()
unsigned int | getDynamicObjectCount () const
virtual void | releaseAllGLObjects ()
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
virtual void | flushAllDeletedGLObjects ()
virtual void | flushDeletedGLObjects (double &availableTime)
bool | getStats (Statistics &primStats)
void | setAutomaticFlush (bool automaticFlush)
bool | getAutomaticFlush () const
void | setResetColorMaskToAllOn (bool enable)
bool | getResetColorMaskToAllOn () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const
Public Member Functions inherited from osg::CullSettings
| CullSettings ()
| CullSettings (ArgumentParser &arguments)
| CullSettings (const CullSettings &cs)
virtual | ~CullSettings ()
CullSettings & | operator= (const CullSettings &settings)
void | setInheritanceMask (InheritanceMask mask)
InheritanceMask | getInheritanceMask () const
void | setCullSettings (const CullSettings &settings)
void | readEnvironmentalVariables ()
void | readCommandLine (ArgumentParser &arguments)
void | setInheritanceMaskActionOnAttributeSetting (InheritanceMaskActionOnAttributeSetting action)
InheritanceMaskActionOnAttributeSetting | getInheritanceMaskActionOnAttributeSetting () const
void | applyMaskAction (unsigned int maskBit)
void | setImpostorsActive (bool active)
bool | getImpostorsActive () const
void | setImpostorPixelErrorThreshold (float numPixels)
float | getImpostorPixelErrorThreshold () const
void | setDepthSortImpostorSprites (bool doDepthSort)
bool | getDepthSortImpostorSprites () const
void | setNumberOfFrameToKeepImpostorSprites (int numFrames)
int | getNumberOfFrameToKeepImpostorSprites () const
void | setComputeNearFarMode (ComputeNearFarMode cnfm)
ComputeNearFarMode | getComputeNearFarMode () const
void | setNearFarRatio (double ratio)
double | getNearFarRatio () const
void | setCullingMode (CullingMode mode)
CullingMode | getCullingMode () const
void | setCullMask (osg::Node::NodeMask nm)
osg::Node::NodeMask | getCullMask () const
void | setCullMaskLeft (osg::Node::NodeMask nm)
osg::Node::NodeMask | getCullMaskLeft () const
void | setCullMaskRight (osg::Node::NodeMask nm)
osg::Node::NodeMask | getCullMaskRight () const
void | setLODScale (float scale)
float | getLODScale () const
void | setSmallFeatureCullingPixelSize (float value)
float | getSmallFeatureCullingPixelSize () const
void | setClampProjectionMatrixCallback (ClampProjectionMatrixCallback *cpmc)
ClampProjectionMatrixCallback * | getClampProjectionMatrixCallback ()
const ClampProjectionMatrixCallback * | getClampProjectionMatrixCallback () const
void | write (std::ostream &out)

## Protected Member Functions

virtual | ~SceneView ()
virtual bool | cullStage (const osg::Matrixd &projection, const osg::Matrixd &modelview, osgUtil::CullVisitor *cullVisitor, osgUtil::StateGraph *rendergraph, osgUtil::RenderStage *renderStage, osg::Viewport *viewport)
void | computeLeftEyeViewport (const osg::Viewport *viewport)
void | computeRightEyeViewport (const osg::Viewport *viewport)
const osg::Matrix | computeMVPW () const
void | clearArea (int x, int y, int width, int height, const osg::Vec4 &color)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::ref_ptr< osg::StateSet > | _localStateSet
osg::RenderInfo | _renderInfo
bool | _initCalled
osg::ref_ptr< osg::NodeVisitor > | _initVisitor
osg::ref_ptr< osg::NodeVisitor > | _updateVisitor
osg::ref_ptr< osgUtil::CullVisitor > | _cullVisitor
osg::ref_ptr< osgUtil::StateGraph > | _stateGraph
osg::ref_ptr< osgUtil::RenderStage > | _renderStage
osg::ref_ptr< ComputeStereoMatricesCallback > | _computeStereoMatricesCallback
osg::ref_ptr< osgUtil::CullVisitor > | _cullVisitorLeft
osg::ref_ptr< osgUtil::StateGraph > | _stateGraphLeft
osg::ref_ptr< osgUtil::RenderStage > | _renderStageLeft
osg::ref_ptr< osg::Viewport > | _viewportLeft
osg::ref_ptr< osgUtil::CullVisitor > | _cullVisitorRight
osg::ref_ptr< osgUtil::StateGraph > | _stateGraphRight
osg::ref_ptr< osgUtil::RenderStage > | _renderStageRight
osg::ref_ptr< osg::Viewport > | _viewportRight
osg::ref_ptr< osg::CollectOccludersVisitor > | _collectOccludersVisitor
osg::ref_ptr< osg::FrameStamp > | _frameStamp
osg::observer_ptr< osg::Camera > | _camera
osg::ref_ptr< osg::Camera > | _cameraWithOwnership
osg::ref_ptr< osg::StateSet > | _globalStateSet
osg::ref_ptr< osg::Light > | _light
osg::ref_ptr< osg::DisplaySettings > | _displaySettings
osg::ref_ptr< osg::StateSet > | _secondaryStateSet
FusionDistanceMode | _fusionDistanceMode
float | _fusionDistanceValue
LightingMode | _lightingMode
bool | _prioritizeTextures
bool | _automaticFlush
bool | _requiresFlush
int | _activeUniforms
double | _previousFrameTime
double | _previousSimulationTime
bool | _redrawInterlacedStereoStencilMask
int | _interlacedStereoStencilWidth
int | _interlacedStereoStencilHeight
unsigned int | _dynamicObjectCount
bool | _resetColorMaskToAllEnabled
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount
Protected Attributes inherited from osg::CullSettings
InheritanceMask | _inheritanceMask
InheritanceMaskActionOnAttributeSetting | _inheritanceMaskActionOnAttributeSetting
ComputeNearFarMode | _computeNearFar
CullingMode | _cullingMode
float | _LODScale
float | _smallFeatureCullingPixelSize
ref_ptr< ClampProjectionMatrixCallback > | _clampProjectionMatrixCallback
double | _nearFarRatio
bool | _impostorActive
bool | _depthSortImpostorSprites
float | _impostorPixelErrorThreshold
int | _numFramesToKeepImpostorSprites
Node::NodeMask | _cullMask
Node::NodeMask | _cullMaskLeft
Node::NodeMask | _cullMaskRight

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

SceneView is deprecated, and is now just kept for backwards compatibility. It is recommend that you use osgViewer::Viewer/Composite in combination with osgViewer::GraphicsWindowEmbedded for embedded rendering support as this provides a greater range of functionality and consistency of API.

## Member Typedef Documentation

## LightingMode

typedef Options osgUtil::SceneView::LightingMode

## Member Enumeration Documentation

## ActiveUniforms

enum osgUtil::SceneView::ActiveUniforms

Enumerator
FRAME_NUMBER_UNIFORM |
FRAME_TIME_UNIFORM |
DELTA_FRAME_TIME_UNIFORM |
SIMULATION_TIME_UNIFORM |
DELTA_SIMULATION_TIME_UNIFORM |
VIEW_MATRIX_UNIFORM |
VIEW_MATRIX_INVERSE_UNIFORM |
DEFAULT_UNIFORMS |
ALL_UNIFORMS |

## FusionDistanceMode

enum osgUtil::SceneView::FusionDistanceMode

FusionDistanceMode is used only when working in stereo.

Enumerator
USE_FUSION_DISTANCE_VALUE | Use fusion distance from the value set on the SceneView.
PROPORTIONAL_TO_SCREEN_DISTANCE | Compute the fusion distance by multiplying the screen distance by the fusion distance value.

## Options

enum osgUtil::SceneView::Options

Enumerator
NO_SCENEVIEW_LIGHT |
HEADLIGHT |
SKY_LIGHT |
COMPILE_GLOBJECTS_AT_INIT |
APPLY_GLOBAL_DEFAULTS |
CLEAR_GLOBAL_STATESET |
STANDARD_SETTINGS |

## Constructor & Destructor Documentation

## SceneView() [1/2]

osgUtil::SceneView::SceneView | ( | osg::DisplaySettings * | ds = NULL | ) |

Construct a default scene view.

References NULL.

Referenced by META_Object(), and SceneView().

## SceneView() [2/2]

osgUtil::SceneView::SceneView | ( | const SceneView & | sceneview,
|  | const osg::CopyOp & | copyop = osg::CopyOp() )

References SceneView().

## ~SceneView()

virtual osgUtil::SceneView::~SceneView | ( |  | ) |

protected virtual

## Member Function Documentation

## clearArea()

void osgUtil::SceneView::clearArea | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height,
|  | const osg::Vec4 & | color )

protected

## clearReferencesToDependentCameras()

void osgUtil::SceneView::clearReferencesToDependentCameras | ( |  | ) |

clear the reference to any any dependent cameras.

## collateReferencesToDependentCameras()

void osgUtil::SceneView::collateReferencesToDependentCameras | ( |  | ) |

search through any pre and post RenderStages that reference a Camera, and take a reference to each of these cameras to prevent them being deleted while they are still be used by the drawing thread.

## computeLeftEyeProjection()

osg::Matrixd osgUtil::SceneView::computeLeftEyeProjection | ( | const osg::Matrixd & | projection | ) | const

inline

References _computeStereoMatricesCallback, and computeLeftEyeProjectionImplementation().

## computeLeftEyeProjectionImplementation()

virtual osg::Matrixd osgUtil::SceneView::computeLeftEyeProjectionImplementation | ( | const osg::Matrixd & | projection | ) | const

virtual

helper function for computing the left eye projection matrix.

Referenced by computeLeftEyeProjection().

## computeLeftEyeView()

osg::Matrixd osgUtil::SceneView::computeLeftEyeView | ( | const osg::Matrixd & | view | ) | const

inline

References _computeStereoMatricesCallback, and computeLeftEyeViewImplementation().

## computeLeftEyeViewImplementation()

virtual osg::Matrixd osgUtil::SceneView::computeLeftEyeViewImplementation | ( | const osg::Matrixd & | view | ) | const

virtual

helper function for computing the left eye view matrix.

Referenced by computeLeftEyeView().

## computeLeftEyeViewport()

void osgUtil::SceneView::computeLeftEyeViewport | ( | const osg::Viewport * | viewport | ) |

protected

## computeMVPW()

const osg::Matrix osgUtil::SceneView::computeMVPW | ( |  | ) | const

protected

## computeRightEyeProjection()

osg::Matrixd osgUtil::SceneView::computeRightEyeProjection | ( | const osg::Matrixd & | projection | ) | const

inline

References _computeStereoMatricesCallback, and computeRightEyeProjectionImplementation().

## computeRightEyeProjectionImplementation()

virtual osg::Matrixd osgUtil::SceneView::computeRightEyeProjectionImplementation | ( | const osg::Matrixd & | projection | ) | const

virtual

helper function for computing the right eye view matrix.

Referenced by computeRightEyeProjection().

## computeRightEyeView()

osg::Matrixd osgUtil::SceneView::computeRightEyeView | ( | const osg::Matrixd & | view | ) | const

inline

References _computeStereoMatricesCallback, and computeRightEyeViewImplementation().

## computeRightEyeViewImplementation()

virtual osg::Matrixd osgUtil::SceneView::computeRightEyeViewImplementation | ( | const osg::Matrixd & | view | ) | const

virtual

helper function for computing the right eye view matrix.

Referenced by computeRightEyeView().

## computeRightEyeViewport()

void osgUtil::SceneView::computeRightEyeViewport | ( | const osg::Viewport * | viewport | ) |

protected

## cull()

virtual void osgUtil::SceneView::cull | ( |  | ) |

virtual

Do cull traversal of the attached scene graph using Cull NodeVisitor.

## cullStage()

virtual bool osgUtil::SceneView::cullStage | ( | const osg::Matrixd & | projection,
|  | const osg::Matrixd & | modelview,
|  | osgUtil::CullVisitor * | cullVisitor,
|  | osgUtil::StateGraph * | rendergraph,
|  | osgUtil::RenderStage * | renderStage,
|  | osg::Viewport * | viewport )

protected virtual

Do cull traversal of attached scene graph using Cull NodeVisitor. Return true if computeNearFar has been done during the cull traversal.

## draw()

virtual void osgUtil::SceneView::draw | ( |  | ) |

virtual

Do draw traversal of draw bins generated by cull traversal.

## flushAllDeletedGLObjects()

virtual void osgUtil::SceneView::flushAllDeletedGLObjects | ( |  | ) |

virtual

Flush all deleted OpenGL objects, such as texture objects, display lists, etc.

## flushDeletedGLObjects()

virtual void osgUtil::SceneView::flushDeletedGLObjects | ( | double & | availableTime | ) |

virtual

Flush deleted OpenGL objects, such as texture objects, display lists, etc., within the specified available time.

## getActiveUniforms()

int osgUtil::SceneView::getActiveUniforms | ( |  | ) | const

inline

Get the uniforms that SceneView should set set up on each frame.

References _activeUniforms.

## getAutomaticFlush()

bool osgUtil::SceneView::getAutomaticFlush | ( |  | ) | const

inline

References _automaticFlush.

## getCamera() [1/2]

osg::Camera * osgUtil::SceneView::getCamera | ( |  | ) |

inline

Get the camera used to represent the camera view of this SceneView.

References _camera.

## getCamera() [2/2]

const osg::Camera * osgUtil::SceneView::getCamera | ( |  | ) | const

inline

Get the const camera used to represent the camera view of this SceneView.

References _camera.

## getClearColor()

const osg::Vec4 & osgUtil::SceneView::getClearColor | ( |  | ) | const

inline

Get the color used in glClearColor.

References _camera.

## getCollectOccludersVisitor() [1/2]

osg::CollectOccludersVisitor * osgUtil::SceneView::getCollectOccludersVisitor | ( |  | ) |

inline

References _collectOccludersVisitor.

## getCollectOccludersVisitor() [2/2]

const osg::CollectOccludersVisitor * osgUtil::SceneView::getCollectOccludersVisitor | ( |  | ) | const

inline

References _collectOccludersVisitor.

## getComputeStereoMatricesCallback() [1/2]

ComputeStereoMatricesCallback * osgUtil::SceneView::getComputeStereoMatricesCallback | ( |  | ) |

inline

References _computeStereoMatricesCallback.

## getComputeStereoMatricesCallback() [2/2]

const ComputeStereoMatricesCallback * osgUtil::SceneView::getComputeStereoMatricesCallback | ( |  | ) | const

inline

References _computeStereoMatricesCallback.

## getCullVisitor() [1/2]

osgUtil::CullVisitor * osgUtil::SceneView::getCullVisitor | ( |  | ) |

inline

References _cullVisitor.

## getCullVisitor() [2/2]

const osgUtil::CullVisitor * osgUtil::SceneView::getCullVisitor | ( |  | ) | const

inline

References _cullVisitor.

## getCullVisitorLeft() [1/2]

osgUtil::CullVisitor * osgUtil::SceneView::getCullVisitorLeft | ( |  | ) |

inline

References _cullVisitorLeft.

## getCullVisitorLeft() [2/2]

const osgUtil::CullVisitor * osgUtil::SceneView::getCullVisitorLeft | ( |  | ) | const

inline

References _cullVisitorLeft.

## getCullVisitorRight() [1/2]

osgUtil::CullVisitor * osgUtil::SceneView::getCullVisitorRight | ( |  | ) |

inline

References _cullVisitorRight.

## getCullVisitorRight() [2/2]

const osgUtil::CullVisitor * osgUtil::SceneView::getCullVisitorRight | ( |  | ) | const

inline

References _cullVisitorRight.

## getDisplaySettings() [1/2]

osg::DisplaySettings * osgUtil::SceneView::getDisplaySettings | ( |  | ) |

inline

Get the DisplaySettings

References _displaySettings.

## getDisplaySettings() [2/2]

const osg::DisplaySettings * osgUtil::SceneView::getDisplaySettings | ( |  | ) | const

inline

Get the const DisplaySettings

References _displaySettings.

## getDrawBufferValue()

GLenum osgUtil::SceneView::getDrawBufferValue | ( |  | ) | const

inline

Get the draw buffer value used at the start of each frame draw.

References _camera.

## getDynamicObjectCount()

unsigned int osgUtil::SceneView::getDynamicObjectCount | ( |  | ) | const

inline

Compute the number of dynamic objects that will be held in the rendering backend

References _dynamicObjectCount.

## getFrameStamp() [1/2]

osg::FrameStamp * osgUtil::SceneView::getFrameStamp | ( |  | ) |

inline

Get the frame stamp for the current frame.

References _frameStamp.

## getFrameStamp() [2/2]

const osg::FrameStamp * osgUtil::SceneView::getFrameStamp | ( |  | ) | const

inline

Get the const frame stamp for the current frame.

References _frameStamp.

## getFusionDistanceMode()

FusionDistanceMode osgUtil::SceneView::getFusionDistanceMode | ( |  | ) | const

inline

Get the FusionDistanceMode.

References _fusionDistanceMode.

## getFusionDistanceValue()

float osgUtil::SceneView::getFusionDistanceValue | ( |  | ) | const

inline

Get the FusionDistanceValue. Note, only used for USE_FUSION_DISTANCE_VALUE & PROPORTIONAL_TO_SCREEN_DISTANCE modes.

References _fusionDistanceValue.

## getGlobalStateSet() [1/2]

osg::StateSet * osgUtil::SceneView::getGlobalStateSet | ( |  | ) |

inline

References _globalStateSet.

## getGlobalStateSet() [2/2]

const osg::StateSet * osgUtil::SceneView::getGlobalStateSet | ( |  | ) | const

inline

References _globalStateSet.

## getInitVisitor() [1/2]

osg::NodeVisitor * osgUtil::SceneView::getInitVisitor | ( |  | ) |

inline

References _initVisitor.

## getInitVisitor() [2/2]

const osg::NodeVisitor * osgUtil::SceneView::getInitVisitor | ( |  | ) | const

inline

References _initVisitor.

## getLight() [1/2]

osg::Light * osgUtil::SceneView::getLight | ( |  | ) |

inline

References _light.

## getLight() [2/2]

const osg::Light * osgUtil::SceneView::getLight | ( |  | ) | const

inline

References _light.

## getLightingMode()

LightingMode osgUtil::SceneView::getLightingMode | ( |  | ) | const

inline

References _lightingMode.

## getLocalStateSet() [1/2]

osg::StateSet * osgUtil::SceneView::getLocalStateSet | ( |  | ) |

inline

References _localStateSet.

## getLocalStateSet() [2/2]

const osg::StateSet * osgUtil::SceneView::getLocalStateSet | ( |  | ) | const

inline

References _localStateSet.

## getNumSceneData()

unsigned int osgUtil::SceneView::getNumSceneData | ( |  | ) | const

inline

Get the number of scene data subgraphs added to the SceneView's camera.

References _camera.

## getPrioritizeTextures()

bool osgUtil::SceneView::getPrioritizeTextures | ( |  | ) | const

inline

Get whether the draw method should call renderer->prioritizeTexture.

References _prioritizeTextures.

## getProjectionMatrix() [1/2]

osg::Matrixd & osgUtil::SceneView::getProjectionMatrix | ( |  | ) |

inline

Get the projection matrix.

References _camera.

## getProjectionMatrix() [2/2]

const osg::Matrixd & osgUtil::SceneView::getProjectionMatrix | ( |  | ) | const

inline

Get the const projection matrix.

References _camera.

## getProjectionMatrixAsFrustum()

bool osgUtil::SceneView::getProjectionMatrixAsFrustum | ( | double & | left,
|  | double & | right,
|  | double & | bottom,
|  | double & | top,
|  | double & | zNear,
|  | double & | zFar ) const

Get the frustum setting of a perspective projection matrix. Returns false if matrix is not a perspective matrix, where parameter values are undefined.

## getProjectionMatrixAsOrtho()

bool osgUtil::SceneView::getProjectionMatrixAsOrtho | ( | double & | left,
|  | double & | right,
|  | double & | bottom,
|  | double & | top,
|  | double & | zNear,
|  | double & | zFar ) const

Get the orthographic settings of the orthographic projection matrix. Returns false if matrix is not an orthographic matrix, where parameter values are undefined.

## getProjectionMatrixAsPerspective()

bool osgUtil::SceneView::getProjectionMatrixAsPerspective | ( | double & | fovy,
|  | double & | aspectRatio,
|  | double & | zNear,
|  | double & | zFar ) const

Get the frustum setting of a symmetric perspective projection matrix. Returns false if matrix is not a perspective matrix, where parameter values are undefined. Note, if matrix is not a symmetric perspective matrix then the shear will be lost. Asymmetric matrices occur when stereo, power walls, caves and reality center display are used. In these configurations one should use the 'getProjectionMatrixAsFrustum' method instead.

## getRedrawInterlacedStereoStencilMask()

bool osgUtil::SceneView::getRedrawInterlacedStereoStencilMask | ( |  | ) | const

inline

Get the redraw interlaced stereo stencil mask request flag.

References _redrawInterlacedStereoStencilMask.

## getRenderInfo() [1/2]

osg::RenderInfo & osgUtil::SceneView::getRenderInfo | ( |  | ) |

inline

References _renderInfo.

## getRenderInfo() [2/2]

const osg::RenderInfo & osgUtil::SceneView::getRenderInfo | ( |  | ) | const

inline

References _renderInfo.

## getRenderStage() [1/2]

osgUtil::RenderStage * osgUtil::SceneView::getRenderStage | ( |  | ) |

inline

References _renderStage.

## getRenderStage() [2/2]

const osgUtil::RenderStage * osgUtil::SceneView::getRenderStage | ( |  | ) | const

inline

References _renderStage.

## getRenderStageLeft() [1/2]

osgUtil::RenderStage * osgUtil::SceneView::getRenderStageLeft | ( |  | ) |

inline

References _renderStageLeft.

## getRenderStageLeft() [2/2]

const osgUtil::RenderStage * osgUtil::SceneView::getRenderStageLeft | ( |  | ) | const

inline

References _renderStageLeft.

## getRenderStageRight() [1/2]

osgUtil::RenderStage * osgUtil::SceneView::getRenderStageRight | ( |  | ) |

inline

References _renderStageRight.

## getRenderStageRight() [2/2]

const osgUtil::RenderStage * osgUtil::SceneView::getRenderStageRight | ( |  | ) | const

inline

References _renderStageRight.

## getResetColorMaskToAllOn()

bool osgUtil::SceneView::getResetColorMaskToAllOn | ( |  | ) | const

inline

References _resetColorMaskToAllEnabled.

## getSceneData() [1/2]

osg::Node * osgUtil::SceneView::getSceneData | ( | unsigned int | childNo = 0 | ) |

inline

Get the scene data to view. The data will typically be an osg::Scene but can be any osg::Node type.

References _camera.

## getSceneData() [2/2]

const osg::Node * osgUtil::SceneView::getSceneData | ( | unsigned int | childNo = 0 | ) | const

inline

Get the const scene data which to view. The data will typically be an osg::Scene but can be any osg::Node type.

References _camera.

## getSecondaryStateSet() [1/2]

osg::StateSet * osgUtil::SceneView::getSecondaryStateSet | ( |  | ) |

inline

References _secondaryStateSet.

## getSecondaryStateSet() [2/2]

const osg::StateSet * osgUtil::SceneView::getSecondaryStateSet | ( |  | ) | const

inline

References _secondaryStateSet.

## getState() [1/2]

osg::State * osgUtil::SceneView::getState | ( |  | ) |

inline

References _renderInfo.

## getState() [2/2]

const osg::State * osgUtil::SceneView::getState | ( |  | ) | const

inline

References _renderInfo.

## getStateGraph() [1/2]

osgUtil::StateGraph * osgUtil::SceneView::getStateGraph | ( |  | ) |

inline

References _stateGraph.

## getStateGraph() [2/2]

const osgUtil::StateGraph * osgUtil::SceneView::getStateGraph | ( |  | ) | const

inline

References _stateGraph.

## getStateGraphLeft() [1/2]

osgUtil::StateGraph * osgUtil::SceneView::getStateGraphLeft | ( |  | ) |

inline

References _stateGraphLeft.

## getStateGraphLeft() [2/2]

const osgUtil::StateGraph * osgUtil::SceneView::getStateGraphLeft | ( |  | ) | const

inline

References _stateGraphLeft.

## getStateGraphRight() [1/2]

osgUtil::StateGraph * osgUtil::SceneView::getStateGraphRight | ( |  | ) |

inline

References _stateGraphRight.

## getStateGraphRight() [2/2]

const osgUtil::StateGraph * osgUtil::SceneView::getStateGraphRight | ( |  | ) | const

inline

References _stateGraphRight.

## getStats()

bool osgUtil::SceneView::getStats | ( | Statistics & | primStats | ) |

Extract stats for current draw list.

## getUpdateVisitor() [1/2]

osg::NodeVisitor * osgUtil::SceneView::getUpdateVisitor | ( |  | ) |

inline

References _updateVisitor.

## getUpdateVisitor() [2/2]

const osg::NodeVisitor * osgUtil::SceneView::getUpdateVisitor | ( |  | ) | const

inline

References _updateVisitor.

## getView() [1/2]

osg::View * osgUtil::SceneView::getView | ( |  | ) |

inline

References _camera.

## getView() [2/2]

const osg::View * osgUtil::SceneView::getView | ( |  | ) | const

inline

References _camera.

## getViewMatrix() [1/2]

osg::Matrixd & osgUtil::SceneView::getViewMatrix | ( |  | ) |

inline

Get the view matrix.

References _camera.

## getViewMatrix() [2/2]

const osg::Matrixd & osgUtil::SceneView::getViewMatrix | ( |  | ) | const

inline

Get the const view matrix.

References _camera.

## getViewMatrixAsLookAt()

void osgUtil::SceneView::getViewMatrixAsLookAt | ( | osg::Vec3 & | eye,
|  | osg::Vec3 & | center,
|  | osg::Vec3 & | up,
|  | float | lookDistance = 1.0f ) const

Get the position and orientation components of a modelview matrix, using the same convention as gluLookAt.

## getViewport() [1/2]

osg::Viewport * osgUtil::SceneView::getViewport | ( |  | ) |

inline

Get the viewport.

References _camera.

## getViewport() [2/2]

const osg::Viewport * osgUtil::SceneView::getViewport | ( |  | ) | const

inline

Get the const viewport.

References _camera.

## inheritCullSettings() [1/2]

virtual void osgUtil::SceneView::inheritCullSettings | ( | const osg::CullSettings & | settings | ) |

inline virtual

Inherit the local cull settings variable from a specified CullSettings object, according to the inheritance mask.

Reimplemented from osg::CullSettings.

References osg::CullSettings::_inheritanceMask, and inheritCullSettings().

Referenced by inheritCullSettings().

## inheritCullSettings() [2/2]

virtual void osgUtil::SceneView::inheritCullSettings | ( | const osg::CullSettings & | settings,
|  | unsigned int | inheritanceMask )

virtual

Inherit the local cull settings variable from a specified CullSettings object, according to the inheritance mask.

Reimplemented from osg::CullSettings.

## init()

virtual void osgUtil::SceneView::init | ( |  | ) |

virtual

Do init traversal of the attached scene graph using Init NodeVisitor. The init traversal is called once for each SceneView, and should be used to compile display lists, texture objects and initialize data not otherwise initialized during scene graph loading. Note, is called automatically by update & cull if it hasn't already been called elsewhere. Also init() should only ever be called within a valid graphics context.

## META_Object()

osgUtil::SceneView::META_Object | ( | osgUtil | ,
|  | SceneView | )

References SceneView().

## projectObjectIntoWindow()

bool osgUtil::SceneView::projectObjectIntoWindow | ( | const osg::Vec3 & | object,
|  | osg::Vec3 & | window ) const

Calculate the window coordinates of a point in object coordinates. Note, current implementation requires that SceneView::draw() has been previously called for projectWindowIntoObject to produce valid values. Consistent with OpenGL, window coordinates are calculated relative to the bottom left of the window, whereas window API's normally have the top left as the origin, so you may need to pass in (mouseX,window_height-mouseY,...). Returns true on successful projection.

## projectWindowIntoObject()

bool osgUtil::SceneView::projectWindowIntoObject | ( | const osg::Vec3 & | window,
|  | osg::Vec3 & | object ) const

Calculate the object coordinates of a point in window coordinates. Note, current implementation requires that SceneView::draw() has been previously called for projectWindowIntoObject to produce valid values. Consistent with OpenGL, window coordinates are calculated relative to the bottom left of the window. Returns true on successful projection.

## projectWindowXYIntoObject()

bool osgUtil::SceneView::projectWindowXYIntoObject | ( | int | x,
|  | int | y,
|  | osg::Vec3 & | near_point,
|  | osg::Vec3 & | far_point ) const

Calculate the object coordinates of a window x,y when projected onto the near and far planes. Note, current implementation requires that SceneView::draw() has been previously called for projectWindowIntoObject to produce valid values. Consistent with OpenGL, window coordinates are calculated relative to the bottom left of the window. Returns true on successful projection.

## releaseAllGLObjects()

virtual void osgUtil::SceneView::releaseAllGLObjects | ( |  | ) |

virtual

Release all OpenGL objects from the scene graph, such as texture objects, display lists, etc. These released scene graphs are placed in the respective delete GLObjects cache, and then need to be deleted in OpenGL by SceneView::flushAllDeleteGLObjects().

## releaseGLObjects()

virtual void osgUtil::SceneView::releaseGLObjects | ( | osg::State * | = 0 | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osg::Object.

## resizeGLObjectBuffers()

virtual void osgUtil::SceneView::resizeGLObjectBuffers | ( | unsigned int |  | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::Object.

## setActiveUniforms()

void osgUtil::SceneView::setActiveUniforms | ( | int | activeUniforms | ) |

inline

Set the uniforms that SceneView should set set up on each frame.

References _activeUniforms.

## setAutomaticFlush()

void osgUtil::SceneView::setAutomaticFlush | ( | bool | automaticFlush | ) |

inline

Set whether the SceneView should automatically call flushDeletedObjects() on each new frame.

References _automaticFlush.

## setCamera()

void osgUtil::SceneView::setCamera | ( | osg::Camera * | camera,
|  | bool | assumeOwnershipOfCamera = true )

Set the camera used to represent the camera view of this SceneView.

## setClearColor()

void osgUtil::SceneView::setClearColor | ( | const osg::Vec4 & | color | ) |

inline

Set the color used in glClearColor(). Defaults to an off blue color.

References _camera.

## setCollectOccludersVisitor()

void osgUtil::SceneView::setCollectOccludersVisitor | ( | osg::CollectOccludersVisitor * | cov | ) |

inline

References _collectOccludersVisitor.

## setComputeStereoMatricesCallback()

void osgUtil::SceneView::setComputeStereoMatricesCallback | ( | ComputeStereoMatricesCallback * | callback | ) |

inline

References _computeStereoMatricesCallback.

## setCullVisitor()

void osgUtil::SceneView::setCullVisitor | ( | osgUtil::CullVisitor * | cv | ) |

inline

References _cullVisitor.

## setCullVisitorLeft()

void osgUtil::SceneView::setCullVisitorLeft | ( | osgUtil::CullVisitor * | cv | ) |

inline

References _cullVisitorLeft.

## setCullVisitorRight()

void osgUtil::SceneView::setCullVisitorRight | ( | osgUtil::CullVisitor * | cv | ) |

inline

References _cullVisitorRight.

## setDefaults() [1/2]

virtual void osgUtil::SceneView::setDefaults | ( |  | ) |

inline virtual

Reimplemented from osg::CullSettings.

References setDefaults(), and STANDARD_SETTINGS.

Referenced by setDefaults().

## setDefaults() [2/2]

virtual void osgUtil::SceneView::setDefaults | ( | unsigned int | options | ) |

virtual

Set scene view to use default global state, light, camera and render visitor.

## setDisplaySettings()

void osgUtil::SceneView::setDisplaySettings | ( | osg::DisplaySettings * | vs | ) |

inline

Set the DisplaySettings.

References _displaySettings.

## setDrawBufferValue()

void osgUtil::SceneView::setDrawBufferValue | ( | GLenum | drawBufferValue | ) |

inline

Set the draw buffer value used at the start of each frame draw. Note, overridden in quad buffer stereo mode

References _camera.

## setFrameStamp()

void osgUtil::SceneView::setFrameStamp | ( | osg::FrameStamp * | fs | ) |

inline

Set the frame stamp for the current frame.

References _frameStamp.

## setFusionDistance()

void osgUtil::SceneView::setFusionDistance | ( | FusionDistanceMode | mode,
|  | float | value = 1.0f )

inline

Set the FusionDistanceMode and Value. Note, is used only when working in stereo.

References _fusionDistanceMode, and _fusionDistanceValue.

## setGlobalStateSet()

void osgUtil::SceneView::setGlobalStateSet | ( | osg::StateSet * | state | ) |

inline

References _globalStateSet.

## setInitVisitor()

void osgUtil::SceneView::setInitVisitor | ( | osg::NodeVisitor * | av | ) |

inline

References _initVisitor.

## setLight()

void osgUtil::SceneView::setLight | ( | osg::Light * | light | ) |

inline

References _light.

## setLightingMode()

void osgUtil::SceneView::setLightingMode | ( | LightingMode | mode | ) |

## setLocalStateSet()

void osgUtil::SceneView::setLocalStateSet | ( | osg::StateSet * | state | ) |

inline

References _localStateSet.

## setPrioritizeTextures()

void osgUtil::SceneView::setPrioritizeTextures | ( | bool | pt | ) |

inline

Set whether the draw method should call renderer->prioritizeTexture.

References _prioritizeTextures.

## setProjectionMatrix() [1/2]

void osgUtil::SceneView::setProjectionMatrix | ( | const osg::Matrixd & | matrix | ) |

inline

Set the projection matrix. Can be thought of as setting the lens of a camera.

References _camera.

## setProjectionMatrix() [2/2]

void osgUtil::SceneView::setProjectionMatrix | ( | const osg::Matrixf & | matrix | ) |

inline

Set the projection matrix. Can be thought of as setting the lens of a camera.

References _camera.

## setProjectionMatrixAsFrustum()

void osgUtil::SceneView::setProjectionMatrixAsFrustum | ( | double | left,
|  | double | right,
|  | double | bottom,
|  | double | top,
|  | double | zNear,
|  | double | zFar )

Set to a perspective projection. See OpenGL glFrustum documentation for further details.

## setProjectionMatrixAsOrtho()

void osgUtil::SceneView::setProjectionMatrixAsOrtho | ( | double | left,
|  | double | right,
|  | double | bottom,
|  | double | top,
|  | double | zNear,
|  | double | zFar )

Set to an orthographic projection. See OpenGL glOrtho documentation for further details.

## setProjectionMatrixAsOrtho2D()

void osgUtil::SceneView::setProjectionMatrixAsOrtho2D | ( | double | left,
|  | double | right,
|  | double | bottom,
|  | double | top )

Set to a 2D orthographic projection. See OpenGL glOrtho2D documentation for further details.

## setProjectionMatrixAsPerspective()

void osgUtil::SceneView::setProjectionMatrixAsPerspective | ( | double | fovy,
|  | double | aspectRatio,
|  | double | zNear,
|  | double | zFar )

Create a symmetrical perspective projection, See OpenGL gluPerspective documentation for further details. Aspect ratio is defined as width/height.

## setRedrawInterlacedStereoStencilMask()

void osgUtil::SceneView::setRedrawInterlacedStereoStencilMask | ( | bool | flag | ) |

inline

Manually set the redraw interlaced stereo stencil mask request flag to control whether to redraw the stencil buffer on the next frame.

References _redrawInterlacedStereoStencilMask.

## setRenderInfo()

void osgUtil::SceneView::setRenderInfo | ( | osg::RenderInfo & | renderInfo | ) |

inline

References _renderInfo.

## setRenderStage()

void osgUtil::SceneView::setRenderStage | ( | osgUtil::RenderStage * | rs | ) |

inline

References _renderStage.

## setRenderStageLeft()

void osgUtil::SceneView::setRenderStageLeft | ( | osgUtil::RenderStage * | rs | ) |

inline

References _renderStageLeft.

## setRenderStageRight()

void osgUtil::SceneView::setRenderStageRight | ( | osgUtil::RenderStage * | rs | ) |

inline

References _renderStageRight.

## setResetColorMaskToAllOn()

void osgUtil::SceneView::setResetColorMaskToAllOn | ( | bool | enable | ) |

inline

References _resetColorMaskToAllEnabled.

## setSceneData()

void osgUtil::SceneView::setSceneData | ( | osg::Node * | node | ) |

Set the data to view. The data will typically be an osg::Scene but can be any osg::Node type.

## setSecondaryStateSet()

void osgUtil::SceneView::setSecondaryStateSet | ( | osg::StateSet * | state | ) |

inline

References _secondaryStateSet.

## setState()

void osgUtil::SceneView::setState | ( | osg::State * | state | ) |

inline

References _renderInfo.

## setStateGraph()

void osgUtil::SceneView::setStateGraph | ( | osgUtil::StateGraph * | rg | ) |

inline

References _stateGraph.

## setStateGraphLeft()

void osgUtil::SceneView::setStateGraphLeft | ( | osgUtil::StateGraph * | rg | ) |

inline

References _stateGraphLeft.

## setStateGraphRight()

void osgUtil::SceneView::setStateGraphRight | ( | osgUtil::StateGraph * | rg | ) |

inline

References _stateGraphRight.

## setUpdateVisitor()

void osgUtil::SceneView::setUpdateVisitor | ( | osg::NodeVisitor * | av | ) |

inline

References _updateVisitor.

## setView()

void osgUtil::SceneView::setView | ( | osg::View * | view | ) |

inline

References _camera.

## setViewMatrix() [1/2]

void osgUtil::SceneView::setViewMatrix | ( | const osg::Matrixd & | matrix | ) |

inline

Set the view matrix. Can be thought of as setting the position of the world relative to the camera in camera coordinates.

References _camera.

## setViewMatrix() [2/2]

void osgUtil::SceneView::setViewMatrix | ( | const osg::Matrixf & | matrix | ) |

inline

Set the view matrix. Can be thought of as setting the position of the world relative to the camera in camera coordinates.

References _camera.

## setViewMatrixAsLookAt()

void osgUtil::SceneView::setViewMatrixAsLookAt | ( | const osg::Vec3 & | eye,
|  | const osg::Vec3 & | center,
|  | const osg::Vec3 & | up )

Set the position and orientation components of the view matrix, using the same convention as gluLookAt.

## setViewport() [1/2]

void osgUtil::SceneView::setViewport | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height )

inline

Set the viewport of the scene view to specified dimensions.

References _camera.

## setViewport() [2/2]

void osgUtil::SceneView::setViewport | ( | osg::Viewport * | viewport | ) |

inline

Set the viewport of the scene view to use specified osg::Viewport.

References _camera.

## update()

virtual void osgUtil::SceneView::update | ( |  | ) |

virtual

Do app traversal of the attached scene graph using App NodeVisitor.

## updateUniforms()

void osgUtil::SceneView::updateUniforms | ( |  | ) |

## Member Data Documentation

## _activeUniforms

int osgUtil::SceneView::_activeUniforms

protected

Referenced by getActiveUniforms(), and setActiveUniforms().

## _automaticFlush

bool osgUtil::SceneView::_automaticFlush

protected

Referenced by getAutomaticFlush(), and setAutomaticFlush().

## _camera

osg::observer_ptr<osg::Camera> osgUtil::SceneView::_camera

protected

Referenced by getCamera(), getCamera(), getClearColor(), getDrawBufferValue(), getNumSceneData(), getProjectionMatrix(), getProjectionMatrix(), getSceneData(), getSceneData(), getView(), getView(), getViewMatrix(), getViewMatrix(), getViewport(), getViewport(), setClearColor(), setDrawBufferValue(), setProjectionMatrix(), setProjectionMatrix(), setView(), setViewMatrix(), setViewMatrix(), setViewport(), and setViewport().

## _cameraWithOwnership

osg::ref_ptr<osg::Camera> osgUtil::SceneView::_cameraWithOwnership

protected

## _collectOccludersVisitor

osg::ref_ptr<osg::CollectOccludersVisitor> osgUtil::SceneView::_collectOccludersVisitor

protected

Referenced by getCollectOccludersVisitor(), getCollectOccludersVisitor(), and setCollectOccludersVisitor().

## _computeStereoMatricesCallback

osg::ref_ptr<ComputeStereoMatricesCallback> osgUtil::SceneView::_computeStereoMatricesCallback

protected

Referenced by computeLeftEyeProjection(), computeLeftEyeView(), computeRightEyeProjection(), computeRightEyeView(), getComputeStereoMatricesCallback(), getComputeStereoMatricesCallback(), and setComputeStereoMatricesCallback().

## _cullVisitor

osg::ref_ptr<osgUtil::CullVisitor> osgUtil::SceneView::_cullVisitor

protected

Referenced by getCullVisitor(), getCullVisitor(), and setCullVisitor().

## _cullVisitorLeft

osg::ref_ptr<osgUtil::CullVisitor> osgUtil::SceneView::_cullVisitorLeft

protected

Referenced by getCullVisitorLeft(), getCullVisitorLeft(), and setCullVisitorLeft().

## _cullVisitorRight

osg::ref_ptr<osgUtil::CullVisitor> osgUtil::SceneView::_cullVisitorRight

protected

Referenced by getCullVisitorRight(), getCullVisitorRight(), and setCullVisitorRight().

## _displaySettings

osg::ref_ptr<osg::DisplaySettings> osgUtil::SceneView::_displaySettings

protected

Referenced by getDisplaySettings(), getDisplaySettings(), and setDisplaySettings().

## _dynamicObjectCount

unsigned int osgUtil::SceneView::_dynamicObjectCount

protected

Referenced by getDynamicObjectCount().

## _frameStamp

osg::ref_ptr<osg::FrameStamp> osgUtil::SceneView::_frameStamp

protected

Referenced by getFrameStamp(), getFrameStamp(), and setFrameStamp().

## _fusionDistanceMode

FusionDistanceMode osgUtil::SceneView::_fusionDistanceMode

protected

Referenced by getFusionDistanceMode(), and setFusionDistance().

## _fusionDistanceValue

float osgUtil::SceneView::_fusionDistanceValue

protected

Referenced by getFusionDistanceValue(), and setFusionDistance().

## _globalStateSet

osg::ref_ptr<osg::StateSet> osgUtil::SceneView::_globalStateSet

protected

Referenced by getGlobalStateSet(), getGlobalStateSet(), and setGlobalStateSet().

## _initCalled

bool osgUtil::SceneView::_initCalled

protected

## _initVisitor

osg::ref_ptr<osg::NodeVisitor> osgUtil::SceneView::_initVisitor

protected

Referenced by getInitVisitor(), getInitVisitor(), and setInitVisitor().

## _interlacedStereoStencilHeight

int osgUtil::SceneView::_interlacedStereoStencilHeight

protected

## _interlacedStereoStencilWidth

int osgUtil::SceneView::_interlacedStereoStencilWidth

protected

## _light

osg::ref_ptr<osg::Light> osgUtil::SceneView::_light

protected

Referenced by getLight(), getLight(), and setLight().

## _lightingMode

LightingMode osgUtil::SceneView::_lightingMode

protected

Referenced by getLightingMode().

## _localStateSet

osg::ref_ptr<osg::StateSet> osgUtil::SceneView::_localStateSet

protected

Referenced by getLocalStateSet(), getLocalStateSet(), and setLocalStateSet().

## _previousFrameTime

double osgUtil::SceneView::_previousFrameTime

protected

## _previousSimulationTime

double osgUtil::SceneView::_previousSimulationTime

protected

## _prioritizeTextures

bool osgUtil::SceneView::_prioritizeTextures

protected

Referenced by getPrioritizeTextures(), and setPrioritizeTextures().

## _redrawInterlacedStereoStencilMask

bool osgUtil::SceneView::_redrawInterlacedStereoStencilMask

protected

Referenced by getRedrawInterlacedStereoStencilMask(), and setRedrawInterlacedStereoStencilMask().

## _renderInfo

osg::RenderInfo osgUtil::SceneView::_renderInfo

protected

Referenced by getRenderInfo(), getRenderInfo(), getState(), getState(), setRenderInfo(), and setState().

## _renderStage

osg::ref_ptr<osgUtil::RenderStage> osgUtil::SceneView::_renderStage

protected

Referenced by getRenderStage(), getRenderStage(), and setRenderStage().

## _renderStageLeft

osg::ref_ptr<osgUtil::RenderStage> osgUtil::SceneView::_renderStageLeft

protected

Referenced by getRenderStageLeft(), getRenderStageLeft(), and setRenderStageLeft().

## _renderStageRight

osg::ref_ptr<osgUtil::RenderStage> osgUtil::SceneView::_renderStageRight

protected

Referenced by getRenderStageRight(), getRenderStageRight(), and setRenderStageRight().

## _requiresFlush

bool osgUtil::SceneView::_requiresFlush

protected

## _resetColorMaskToAllEnabled

bool osgUtil::SceneView::_resetColorMaskToAllEnabled

protected

Referenced by getResetColorMaskToAllOn(), and setResetColorMaskToAllOn().

## _secondaryStateSet

osg::ref_ptr<osg::StateSet> osgUtil::SceneView::_secondaryStateSet

protected

Referenced by getSecondaryStateSet(), getSecondaryStateSet(), and setSecondaryStateSet().

## _stateGraph

osg::ref_ptr<osgUtil::StateGraph> osgUtil::SceneView::_stateGraph

protected

Referenced by getStateGraph(), getStateGraph(), and setStateGraph().

## _stateGraphLeft

osg::ref_ptr<osgUtil::StateGraph> osgUtil::SceneView::_stateGraphLeft

protected

Referenced by getStateGraphLeft(), getStateGraphLeft(), and setStateGraphLeft().

## _stateGraphRight

osg::ref_ptr<osgUtil::StateGraph> osgUtil::SceneView::_stateGraphRight

protected

Referenced by getStateGraphRight(), getStateGraphRight(), and setStateGraphRight().

## _updateVisitor

osg::ref_ptr<osg::NodeVisitor> osgUtil::SceneView::_updateVisitor

protected

Referenced by getUpdateVisitor(), getUpdateVisitor(), and setUpdateVisitor().

## _viewportLeft

osg::ref_ptr<osg::Viewport> osgUtil::SceneView::_viewportLeft

protected

## _viewportRight

osg::ref_ptr<osg::Viewport> osgUtil::SceneView::_viewportRight

protected

The documentation for this class was generated from the following file:

- SceneView